#pragma once

#include "Entity.h"
#include "EntityType.h"

class ItemEntityType;

class ItemEntity : public Entity
{
    ItemSlot* slot;

public:
    ItemEntity( Framework::Vec3<float> location, int dimensionId, int entityId );

    void tick( const Dimension* zDimension ) override;

    void api( Framework::StreamReader* zRequest, NetworkResponse* zResponse ) override;
    void onFall( float collisionSpeed ) override;

    friend ItemEntityType;
};

class ItemEntityType : public EntityType
{
    REGISTRABLE( ItemEntityType )

public:
    ItemEntityType();

    virtual Entity* createEntity( Framework::Vec3<float> position, int dimensionId, int entityId ) const override;
};
REGISTER( ItemEntityType, EntityType )